/**
 * Server Socket Example.
 *
 */
#include <string.h>
#include <pnsock.h>

int main(void)
{
	int connfd=0;
	int sockfd=0;
	int clilen=0;
	struct sockaddr_in serv_addr;
	struct sockaddr_in cliaddr;
	unsigned short port=9988;

	pnsock_startup();

	/* open server-side socket */
	memset(&serv_addr, 0x00, sizeof(serv_addr));
	sockfd = pnsock_open(&serv_addr, port);
	if(sockfd == -1) {
		perror("pnsock_open error");
		return -1;
	}

	while(1) {
		/* accept client connection */
		memset(&cliaddr, 0x00, sizeof(cliaddr));
		clilen = sizeof(clilen);
		connfd = pnsock_accept(sockfd, &cliaddr, &clilen);
		printf("pnsock_accept: new connection: %d\n", connfd);

		/* close after 10 secs. */
#ifdef _WIN32
		Sleep(10000);
#else
		sleep(10);
#endif
		pnsock_close((unsigned short)connfd);
		printf("pnsock_accept: socket closed: %d\n", connfd);
	}

	pnsock_cleanup();
}
