/**
 * Portable Network Library Example.
 * Echo Server.
 */
#include <string.h>
#include <pnsock.h>

int main(void)
{
	int connfd=0;
	int sockfd=0;
	int clilen=0;
	int retval=0;
	char msg[1024];
	unsigned short port=9988;
	struct sockaddr_in serv_addr;
	struct sockaddr_in cliaddr;


	/* it'OK even if not called on UNIX system. */
	pnsock_startup();

	/* open server side socket */
	memset(&serv_addr, 0x00, sizeof(serv_addr));
	sockfd = pnsock_open(&serv_addr, port);
	if(sockfd == -1) {
		perror("pnsock_open error");
		return -1;
	}

	while(1) {
		/* accept client connection */
		memset(&cliaddr, 0x00, sizeof(cliaddr));
		clilen = sizeof(clilen);
		connfd = pnsock_accept(sockfd, &cliaddr, &clilen);
		printf("pnsock_accept: new connection: %d\n", connfd);

		while(1) {
			/* RECV */
			memset(msg, 0x00, sizeof(msg));
			retval = pnsock_recv(connfd, &msg, sizeof(msg));
			if(retval == 0) {
				fprintf(stdout, "Client disconnected\n");
				break;
			}
			if(retval == -1) {
				fprintf(stderr, "pnsock_recv error\n");
				break;
			}
			msg[retval] = 0x00;
			printf("RECV: %s\n", msg);

			/* SEND */
			pnsock_send(connfd, &msg, retval);
			printf("SENT: %s\n", msg);
		}

		/* close client socket */
		pnsock_close((unsigned short)connfd);
		printf("pnsock_accept: socket closed: %d\n", connfd);
	}

	/* close server socket */
	pnsock_close((unsigned short)sockfd);

	// clean
	pnsock_cleanup();
}
